package com.ruoyi;

import com.ruoyi.domain.ReviewDetails;
import com.ruoyi.domain.ReviewKeyPoint;
import com.ruoyi.domain.ReviewScene;
import com.ruoyi.domain.ReviewStandard;
import com.ruoyi.service.ReviewDetailsService;
import com.ruoyi.service.ReviewKeyPointService;
import com.ruoyi.service.ReviewSceneService;
import com.ruoyi.service.ReviewStandardService;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

@SpringBootTest
public class InspectionContentTest {

    @Autowired
    private ReviewKeyPointService reviewKeyPointService;

    @Autowired
    private ReviewDetailsService reviewDetailsService;

    @Autowired
    private ReviewSceneService reviewSceneService;

    @Autowired
    private ReviewStandardService reviewStandardService;

    // 标准新增
    @Test
    public void standardAdd() {
        ReviewStandard build = ReviewStandard.builder()
                .chapter("7.1.1.2")
                .text("车端具备远程控制功能的系统、授权的第三方应用等外部连接系统不应存在由汽车行业权威漏洞平台6个月前公布且未经处置的高危及以上的安全漏洞。\n" +
                        "\n" +
                        "注1：汽车行业权威漏洞平台如车联网产品专用漏洞库NVDB-CAVD等政府主管部门认可的其他漏洞平台。\n" +
                        "\n" +
                        "注2：处置包括消除漏洞、制定减缓措施等方式。")
                .testMethod("测试人员应使用漏洞扫描工具对车辆外部连接系统进行漏洞扫描，并将测试结果与汽车行业权威漏洞平台6个月前公布的高危及以上的安全漏洞清单和车辆生产企业提供的车辆外部连接系统漏洞处置方案进行比对，测试车辆是否满足7.1.1.1的要求。")
                .build();
        reviewStandardService.save(build);
    }

    // 要点新增
    @Test
    public void pointAdd() {
        ReviewKeyPoint build = ReviewKeyPoint.builder()
                .text("车辆全生命周期每个阶段的流程文件能够包含相应阶段的信息安全活动及要求。")
                .reviewStandardId(1735216941104238592L)
                .build();
        reviewKeyPointService.save(build);
    }

    // 细则新增
    @Test
    public void detailsAdd() {
        ReviewDetails build = ReviewDetails.builder()
                .text("后生产阶段流程文件应考虑运维阶段、终止支持、退役阶段的信息安全需求，运维阶段包含网络安全事件响应和软件升级。")
                .reviewKeypointId(1760578720524886017L)
                .build();
        reviewDetailsService.save(build);
    }

    // 场景新增
    @Test
    public void sceneAdd() {
        ReviewScene build = ReviewScene.builder()
                .text("--")
                .reviewDetailsId(1760579778101854209L)
                .build();
        reviewSceneService.save(build);
    }

}
